#!/bin/bash
# Zipit uboot flasher for z2buntu/rootnexus/debian

echo "************************************************"
echo "Zipit uboot flasher for z2buntu/rootnexus/debian"
echo "************************************************"
echo ""
echo "WARNING: THIS COULD BRICK YOUR ZIPIT!"
echo "No one but YOU is responsible if something"
echo "goes wrong. "
echo ""
echo "You must agree to the following license"
echo "terms to install the kernel provided."
echo "If you do not agree to these terms, the "
echo "installation will be cancelled."
echo ""
read -p "Press ENTER to continue..." ENTER
cat LICENSE | more -d

read -p "Do you agree to these terms/conditions? (yes/no): " AGREE
if [ "$AGREE" != "yes" ]; then
  echo "You did not agree. Did you type \"yes\" correctly?"
  echo "exiting..."
  exit 0
fi

echo ""
echo "Make sure your Zipit is fully charged and"
echo "you have the AC Adapter plugged in. "
echo ""
read -p "Last chance before flashing. Are you sure? (yes/no): " AGREE2
if [ "$AGREE2" != "yes" ]; then
  echo "You chose not to continue."
  echo "Did you type \"yes\" correctly?"
  echo "exiting..."
  exit 0
fi

echo ""
echo "Fixing mtdblocks"
rm /dev/mtdblock0
mknod /dev/mtdblock0 b 31 0
rm /dev/mtdblock1
mknod /dev/mtdblock1 b 31 1

echo "Erasing mtdblock0 and mtdblock1..."
dd if=/dev/zero of=/dev/mtdblock0
dd if=/dev/zero of=/dev/mtdblock1

echo "Writing uBoot Part 1..."
dd if=pt1.bin of=/dev/mtdblock0
echo "Writing uBoot Part 2..."
dd if=pt2.bin of=/dev/mtdblock1
echo "uBoot flash finished"

echo "Fixing mtdblocks..."
rm /dev/mtdblock0
rm /dev/mtdblock1
rm /dev/mtdblock2
mknod /dev/mtdblock0 b 31 0
mknod /dev/mtdblock1 b 31 1
mknod /dev/mtdblock2 b 31 2

echo "Erasing mtdblock2..."
dd if=/dev/zero of=/dev/mtdblock2

echo "Writing kernel..."
dd if=uImage-2.6.35-rc3-static of=/dev/mtdblock2
echo "Kernel flash finished!"
echo "After the system is halted, unplug the AC Power"
echo "and remove the battery for a moment. After you"
echo "reattach the battery the system should boot."
echo "Have your SD card with the proper partitions"
echo "inserted."
echo "Shutting down the system..."
poweroff
